/*
Copyright (C) 2012-2014 Baker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
// command_sys.h - command interpreter and processor

#ifndef __COMMAND_SYS_H__
#define __COMMAND_SYS_H__

typedef struct
{
	const char *name;
	int (*command_fn) (sysobj_t *, lparse_t *);
	const char *helptext;
} cmdinfo_t;

typedef struct cmdsys_s
{
// required public function, must be top
	__OBJ_REQUIRED__

// public functions

	void *(*CommandAdd)		(struct cmdsys_s *me, sysobj_t *object, cmdinfo_t *cmdinfo);
	void *(*CommandAddX)	(struct cmdsys_s *me, const char *name, int (*command_fn) (sysobj_t *, lparse_t *), const char *helptext);
	void *(*CommandRemove)	(struct cmdsys_s *me, cmdinfo_t *cmdinfo);
	void  (*Report)			(struct cmdsys_s *me);

	void  (*AddText)		(struct cmdsys_s *me, const char *text);
	void  (*InsertText)		(struct cmdsys_s *me, const char *text);
	int   (*ExecuteString)	(struct cmdsys_s *me, const char *text);
	void  (*Execute)		(struct cmdsys_s *me);

// public variables

// private members
	void*			_local;
} cmdsys_t;

cmdsys_t *CmdSys_Instance (void);



#endif // __COMMAND_SYS_H__



