/*
Copyright (C) 2014-2014 Baker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
// netcon.h -- network connection object

#ifndef __NETSERV_H__
#define __NETSERV_H__


enum ip_protocol_e { NETO_INVALID = 0, NETO_TCP = 1, NETO_UDP = 2, NETO_TCP_UDP = 3};


typedef struct netserv_s
{
// required public function, must be top
	__OBJ_REQUIRED__

// public functions
//	void *(*Malloc) (struct memchain_s *me, size_t n);
//	void *(*Calloc) (struct memchain_s *me, size_t len, size_t n);
//	char *(*Strdup) (struct memchain_s *me, const char *s);
//	void *(*Free)   (struct memchain_s *me, void *ptr);
//	void *(*Realloc)(struct memchain_s *me, void *ptr, size_t len);
//	void *(*Memdup) (struct memchain_s *me, const void *src, size_t len);
	cbool (*Listen) (struct netserv_s *me);
//	void (*Flush)	(struct memchain_s *me);

// public variables
	const char					*ip_requested;
	int							port;

	enum ip_protocol_e			ip_protocol;
	int							af_family;
	
	struct sockaddr_storage		servaddr;
	sys_sock_t					socket;					// Listening sockets
	
// private members
	void*			_local;
} netserv_t;


netserv_t *Netserv_TCP_Instance (const char *ip_address, int port);


#endif // ! __NETSERV_H__





